Imports Syncfusion.Runtime.Serialization
Imports Syncfusion.Windows.Forms.Tools

Public Class Form1
    Dim flag As Boolean = True
    Dim count As Integer = 0
    Dim tmm As TabbedMDIManager
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.IsMdiContainer = True
        tmm = New TabbedMDIManager()
        tmm.AttachToMdiContainer(Me)
        AddHandler Me.FormClosing, AddressOf Form1_FormClosing
        AddHandler DockingManager1.NewDockStateEndLoad, AddressOf dockingManager1_NewDockStateEndLoad
        AddHandler Me.SizeChanged, AddressOf Form1_SizeChanged
    End Sub
    Private Sub Form1_SizeChanged(ByVal sender As Object, ByVal e As EventArgs)
        Console.WriteLine("Form1 size changed event triggered")
        'Checks if the window state is minimized. If it is true,Dock visibility is false. 
        'otherwise visibility set to true. 
        If Me.WindowState = FormWindowState.Minimized Then
            Me.SaveDockStateInfo()
            Me.DockingManager1.SetDockVisibility(Me.Panel1, False)
        Else
            Me.DockingManager1.SetDockVisibility(Me.Panel1, True)
            Me.LoadDockStateInfo()
        End If

    End Sub
    Private Sub dockingManager1_NewDockStateEndLoad(ByVal sender As Object, ByVal e As EventArgs)
        If flag Then
            flag = False
            LoadDockStateInfo()
        End If
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs)
        SaveDockStateInfo()
    End Sub
    Private Sub SaveDockStateInfo()
        Dim temp As ArrayList = New ArrayList()
        For Each c As Control In Me.DockingManager1.ControlsArray
            temp.Add(c.Name)
        Next c
        Dim aser As AppStateSerializer = New AppStateSerializer(SerializeMode.XMLFile, "c:\docksettings")
        aser.SerializeObject("runtimecontrols", temp)
        Me.DockingManager1.SaveDockState(aser)
        aser.PersistNow()

    End Sub
    'To load dock states
    Private Sub LoadDockStateInfo()
        Try

            Dim aser As AppStateSerializer = New AppStateSerializer(SerializeMode.XMLFile, "c:\docksettings")
            Dim temp As ArrayList = New ArrayList()
            temp = CType(aser.DeserializeObject("runtimecontrols"), ArrayList)
            Dim p As Panel() = New Panel(temp.Count - 1) {}
            Dim i As Integer = 0
            'ORIGINAL LINE: for (int i = 0; i < temp.Count; i += 1)
            'INSTANT VB NOTE: This 'for' loop was translated to a VB 'Do While' loop:
            Do While i < temp.Count
                p(i) = New Panel()
                p(i).Name = CStr(temp(i))
                Me.Controls.Add(p(i))
                Me.DockingManager1.SetEnableDocking(p(i), True)
                i += 1
            Loop

            Me.DockingManager1.LoadDockState(aser)

        Catch ex As Exception
        End Try
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim rn As Random = New Random()
        count = rn.Next() Mod 1000
        Dim panel As Panel = New Panel()
        panel.Name = "panel" & count.ToString()
        Me.DockingManager1.SetEnableDocking(panel, True)
        'Me.DockingManager1.DockControl(panel, Me.Panel1, DockingStyle.Tabbed, 100)
        Me.DockingManager1.SetAsMDIChild(panel, True)
        MessageBox.Show(Me.DockingManager1.IsMDIMode(panel).ToString())
    End Sub
End Class
